diff --git a/media/webrtc/trunk/tools/gyp/test/ios/gyptest-extension.py b/media/webrtc/trunk/tools/gyp/test/ios/gyptest-extension.py
index c5e76d93ff..ed313ffe01 100755
--- a/media/webrtc/trunk/tools/gyp/test/ios/gyptest-extension.py
+++ b/media/webrtc/trunk/tools/gyp/test/ios/gyptest-extension.py
@@ -15,12 +15,12 @@ import sys
 
 def CheckStrip(p, expected):
   if expected not in subprocess.check_output(['nm','-gU', p]):
-    print expected + " shouldn't get stripped out."
+    print(expected + " shouldn't get stripped out.")
     test.fail_test()
 
 def CheckEntrypoint(p, expected):
   if expected not in subprocess.check_output(['nm', p]):
-    print expected + "not found."
+    print(expected + "not found.")
     test.fail_test()
 
 if sys.platform == 'darwin' and TestMac.Xcode.Version()>="0600":
diff --git a/media/webrtc/trunk/tools/gyp/test/ios/gyptest-per-config-settings.py b/media/webrtc/trunk/tools/gyp/test/ios/gyptest-per-config-settings.py
index 7313e56343..6371509ac4 100644
--- a/media/webrtc/trunk/tools/gyp/test/ios/gyptest-per-config-settings.py
+++ b/media/webrtc/trunk/tools/gyp/test/ios/gyptest-per-config-settings.py
@@ -22,7 +22,7 @@ def CheckFileType(file, expected):
   o = proc.communicate()[0].strip()
   assert not proc.returncode
   if not expected in o:
-    print 'File: Expected %s, got %s' % (expected, o)
+    print('File: Expected {}, got {}'.format(expected, o))
     test.fail_test()
 
 def HasCerts():
@@ -37,7 +37,7 @@ def CheckSignature(file):
   o = proc.communicate()[0].strip()
   assert not proc.returncode
   if "code object is not signed at all" in o:
-    print 'File %s not properly signed.' % (file)
+    print('File %s not properly signed.' % (file))
     test.fail_test()
 
 def CheckEntitlements(file, expected_entitlements):
@@ -49,10 +49,10 @@ def CheckEntitlements(file, expected_entitlements):
     data = temp.read()
   entitlements = ParseEntitlements(data)
   if not entitlements:
-    print 'No valid entitlements found in %s.' % (file)
+    print('No valid entitlements found in %s.' % (file))
     test.fail_test()
   if entitlements != expected_entitlements:
-    print 'Unexpected entitlements found in %s.' % (file)
+    print('Unexpected entitlements found in %s.' % (file))
     test.fail_test()
 
 def ParseEntitlements(data):
@@ -75,17 +75,17 @@ def GetMachineBuild():
 
 def CheckPlistvalue(plist, key, expected):
   if key not in plist:
-    print '%s not set in plist' % key
+    print('%s not set in plist' % key)
     test.fail_test()
     return
   actual = plist[key]
   if actual != expected:
-    print 'File: Expected %s, got %s for %s' % (expected, actual, key)
+    print('File: Expected {}, got {} for {}'.format(expected, actual, key))
     test.fail_test()
 
 def CheckPlistNotSet(plist, key):
   if key in plist:
-    print '%s should not be set in plist' % key
+    print('%s should not be set in plist' % key)
     test.fail_test()
     return
 
@@ -111,7 +111,7 @@ if sys.platform == 'darwin':
     xcode_version = TestMac.Xcode.Version()
     if xcode_version >= '0720':
       if len(plist) != 23:
-        print 'plist should have 23 entries, but it has %s' % len(plist)
+        print('plist should have 23 entries, but it has %s' % len(plist))
         test.fail_test()
 
     # Values that will hopefully never change.
diff --git a/media/webrtc/trunk/tools/gyp/test/ios/gyptest-watch.py b/media/webrtc/trunk/tools/gyp/test/ios/gyptest-watch.py
index f5c4601d81..885637421a 100755
--- a/media/webrtc/trunk/tools/gyp/test/ios/gyptest-watch.py
+++ b/media/webrtc/trunk/tools/gyp/test/ios/gyptest-watch.py
@@ -14,7 +14,7 @@ import TestMac
 import sys
 
 if sys.platform == 'darwin':
-  print "This test is currently disabled: https://crbug.com/483696."
+  print("This test is currently disabled: https://crbug.com/483696.")
   sys.exit(0)
 
 
diff --git a/media/webrtc/trunk/tools/gyp/test/lib/TestCmd.py b/media/webrtc/trunk/tools/gyp/test/lib/TestCmd.py
index da27cc8288..850d933dbc 100644
--- a/media/webrtc/trunk/tools/gyp/test/lib/TestCmd.py
+++ b/media/webrtc/trunk/tools/gyp/test/lib/TestCmd.py
@@ -226,6 +226,7 @@ import shutil
 import stat
 import string
 import sys
+import atexit
 import tempfile
 import time
 import traceback
@@ -250,7 +251,7 @@ except ImportError:
     __all__.append('simple_diff')
 
 def is_List(e):
-    return type(e) is types.ListType \
+    return type(e) is list \
         or isinstance(e, UserList.UserList)
 
 try:
@@ -261,12 +262,12 @@ except ImportError:
 
 if hasattr(types, 'UnicodeType'):
     def is_String(e):
-        return type(e) is types.StringType \
-            or type(e) is types.UnicodeType \
+        return type(e) is bytes \
+            or type(e) is str \
             or isinstance(e, UserString)
 else:
     def is_String(e):
-        return type(e) is types.StringType or isinstance(e, UserString)
+        return type(e) is bytes or isinstance(e, UserString)
 
 tempfile.template = 'testcmd.'
 if os.name in ('posix', 'nt'):
@@ -274,7 +275,7 @@ if os.name in ('posix', 'nt'):
 else:
     tempfile.template = 'testcmd.'
 
-re_space = re.compile('\s')
+re_space = re.compile(r'\s')
 
 _Cleanup = []
 
@@ -282,7 +283,7 @@ _chain_to_exitfunc = None
 
 def _clean():
     global _Cleanup
-    cleanlist = filter(None, _Cleanup)
+    cleanlist = [_f for _f in _Cleanup if _f]
     del _Cleanup[:]
     cleanlist.reverse()
     for test in cleanlist:
@@ -298,7 +299,7 @@ except ImportError:
         _chain_to_exitfunc = sys.exitfunc
     except AttributeError:
         pass
-    sys.exitfunc = _clean
+    atexit.register(_clean)
 else:
     atexit.register(_clean)
 
@@ -307,7 +308,7 @@ try:
 except NameError:
     def zip(*lists):
         result = []
-        for i in xrange(min(map(len, lists))):
+        for i in range(min(list(map(len, lists)))):
             result.append(tuple(map(lambda l, i=i: l[i], lists)))
         return result
 
@@ -316,7 +317,7 @@ class Collector:
         self.entries = [top]
     def __call__(self, arg, dirname, names):
         pathjoin = lambda n, d=dirname: os.path.join(d, n)
-        self.entries.extend(map(pathjoin, names))
+        self.entries.extend(list(map(pathjoin, names)))
 
 def _caller(tblist, skip):
     string = ""
@@ -433,9 +434,9 @@ def match_re(lines = None, res = None):
         s = "^" + res[i] + "$"
         try:
             expr = re.compile(s)
-        except re.error, e:
+        except re.error as e:
             msg = "Regular expression error in %s: %s"
-            raise re.error, msg % (repr(s), e[0])
+            raise re.error(msg % (repr(s), e[0]))
         if not expr.search(lines[i]):
             return
     return 1
@@ -443,16 +444,16 @@ def match_re(lines = None, res = None):
 def match_re_dotall(lines = None, res = None):
     """
     """
-    if not type(lines) is type(""):
+    if not type(lines) is str:
         lines = string.join(lines, "\n")
-    if not type(res) is type(""):
+    if not type(res) is str:
         res = string.join(res, "\n")
     s = "^" + res + "$"
     try:
         expr = re.compile(s, re.DOTALL)
-    except re.error, e:
+    except re.error as e:
         msg = "Regular expression error in %s: %s"
-        raise re.error, msg % (repr(s), e[0])
+        raise re.error(msg % (repr(s), e[0]))
     if expr.match(lines):
         return 1
 
@@ -470,20 +471,20 @@ else:
         """
         sm = difflib.SequenceMatcher(None, a, b)
         def comma(x1, x2):
-            return x1+1 == x2 and str(x2) or '%s,%s' % (x1+1, x2)
+            return x1+1 == x2 and str(x2) or '{},{}'.format(x1+1, x2)
         result = []
         for op, a1, a2, b1, b2 in sm.get_opcodes():
             if op == 'delete':
                 result.append("%sd%d" % (comma(a1, a2), b1))
-                result.extend(map(lambda l: '< ' + l, a[a1:a2]))
+                result.extend(['< ' + l for l in a[a1:a2]])
             elif op == 'insert':
                 result.append("%da%s" % (a1, comma(b1, b2)))
-                result.extend(map(lambda l: '> ' + l, b[b1:b2]))
+                result.extend(['> ' + l for l in b[b1:b2]])
             elif op == 'replace':
-                result.append("%sc%s" % (comma(a1, a2), comma(b1, b2)))
-                result.extend(map(lambda l: '< ' + l, a[a1:a2]))
+                result.append("{}c{}".format(comma(a1, a2), comma(b1, b2)))
+                result.extend(['< ' + l for l in a[a1:a2]])
                 result.append('---')
-                result.extend(map(lambda l: '> ' + l, b[b1:b2]))
+                result.extend(['> ' + l for l in b[b1:b2]])
         return result
 
 def diff_re(a, b, fromfile='', tofile='',
@@ -506,11 +507,11 @@ def diff_re(a, b, fromfile='', tofile='',
         s = "^" + aline + "$"
         try:
             expr = re.compile(s)
-        except re.error, e:
+        except re.error as e:
             msg = "Regular expression error in %s: %s"
-            raise re.error, msg % (repr(s), e[0])
+            raise re.error(msg % (repr(s), e[0]))
         if not expr.search(bline):
-            result.append("%sc%s" % (i+1, i+1))
+            result.append("{}c{}".format(i+1, i+1))
             result.append('< ' + repr(a[i]))
             result.append('---')
             result.append('> ' + repr(b[i]))
@@ -564,7 +565,7 @@ else:
                     st = os.stat(f)
                 except OSError:
                     continue
-                if stat.S_IMODE(st[stat.ST_MODE]) & 0111:
+                if stat.S_IMODE(st[stat.ST_MODE]) & 0o111:
                     return f
         return None
 
@@ -652,14 +653,14 @@ except ImportError:
             universal_newlines = 1
             def __init__(self, command, **kw):
                 if kw.get('stderr') == 'STDOUT':
-                    apply(popen2.Popen4.__init__, (self, command, 1))
+                    popen2.Popen4.__init__(*(self, command, 1))
                 else:
-                    apply(popen2.Popen3.__init__, (self, command, 1))
+                    popen2.Popen3.__init__(*(self, command, 1))
                 self.stdin = self.tochild
                 self.stdout = self.fromchild
                 self.stderr = self.childerr
             def wait(self, *args, **kw):
-                resultcode = apply(popen2.Popen3.wait, (self,)+args, kw)
+                resultcode = popen2.Popen3.wait(*(self,)+args, **kw)
                 if os.WIFEXITED(resultcode):
                     return os.WEXITSTATUS(resultcode)
                 elif os.WIFSIGNALED(resultcode):
@@ -722,7 +723,7 @@ class Popen(subprocess.Popen):
                 (errCode, written) = WriteFile(x, input)
             except ValueError:
                 return self._close('stdin')
-            except (subprocess.pywintypes.error, Exception), why:
+            except (subprocess.pywintypes.error, Exception) as why:
                 if why[0] in (109, errno.ESHUTDOWN):
                     return self._close('stdin')
                 raise
@@ -743,7 +744,7 @@ class Popen(subprocess.Popen):
                     (errCode, read) = ReadFile(x, nAvail, None)
             except ValueError:
                 return self._close(which)
-            except (subprocess.pywintypes.error, Exception), why:
+            except (subprocess.pywintypes.error, Exception) as why:
                 if why[0] in (109, errno.ESHUTDOWN):
                     return self._close(which)
                 raise
@@ -762,7 +763,7 @@ class Popen(subprocess.Popen):
 
             try:
                 written = os.write(self.stdin.fileno(), input)
-            except OSError, why:
+            except OSError as why:
                 if why[0] == errno.EPIPE: #broken pipe
                     return self._close('stdin')
                 raise
@@ -839,7 +840,7 @@ except NameError:
 
 
 
-class TestCmd(object):
+class TestCmd:
     """Class TestCmd
     """
 
@@ -882,7 +883,7 @@ class TestCmd(object):
                 #self.diff_function = difflib.unified_diff
         self._dirlist = []
         self._preserve = {'pass_test': 0, 'fail_test': 0, 'no_result': 0}
-        if os.environ.has_key('PRESERVE') and not os.environ['PRESERVE'] is '':
+        if 'PRESERVE' in os.environ and not os.environ['PRESERVE'] == '':
             self._preserve['pass_test'] = os.environ['PRESERVE']
             self._preserve['fail_test'] = os.environ['PRESERVE']
             self._preserve['no_result'] = os.environ['PRESERVE']
@@ -947,7 +948,7 @@ class TestCmd(object):
 
     def canonicalize(self, path):
         if is_List(path):
-            path = apply(os.path.join, tuple(path))
+            path = os.path.join(*tuple(path))
         if not os.path.isabs(path):
             path = os.path.join(self.workdir, path)
         return path
@@ -981,7 +982,7 @@ class TestCmd(object):
             condition = self.condition
         if self._preserve[condition]:
             for dir in self._dirlist:
-                print "Preserved directory", dir
+                print("Preserved directory", dir)
         else:
             list = self._dirlist[:]
             list.reverse()
@@ -1000,7 +1001,7 @@ class TestCmd(object):
                            interpreter = None,
                            arguments = None):
         if program:
-            if type(program) == type('') and not os.path.isabs(program):
+            if type(program) == str and not os.path.isabs(program):
                 program = os.path.join(self._cwd, program)
         else:
             program = self.program
@@ -1014,7 +1015,7 @@ class TestCmd(object):
                 interpreter = [interpreter]
             cmd = list(interpreter) + cmd
         if arguments:
-            if type(arguments) == type(''):
+            if type(arguments) == str:
                 arguments = string.split(arguments)
             cmd.extend(arguments)
         return cmd
@@ -1028,17 +1029,17 @@ class TestCmd(object):
         difflib
     except NameError:
         def diff(self, a, b, name, *args, **kw):
-            print self.banner('Expected %s' % name)
-            print a
-            print self.banner('Actual %s' % name)
-            print b
+            print(self.banner('Expected %s' % name))
+            print(a)
+            print(self.banner('Actual %s' % name))
+            print(b)
     else:
         def diff(self, a, b, name, *args, **kw):
-            print self.banner(name)
+            print(self.banner(name))
             args = (a.splitlines(), b.splitlines()) + args
-            lines = apply(self.diff_function, args, kw)
+            lines = self.diff_function(*args, **kw)
             for l in lines:
-                print l
+                print(l)
 
     def fail_test(self, condition = 1, function = None, skip = 0):
         """Cause the test to fail.
@@ -1126,7 +1127,7 @@ class TestCmd(object):
         """
         file = self.canonicalize(file)
         if mode[0] != 'r':
-            raise ValueError, "mode must begin with 'r'"
+            raise ValueError("mode must begin with 'r'")
         with open(file, mode) as f:
             result = f.read()
         return result
@@ -1154,7 +1155,7 @@ class TestCmd(object):
         prepended unless it is enclosed in a [list].
         """
         cmd = self.command_args(program, interpreter, arguments)
-        cmd_string = string.join(map(self.escape, cmd), ' ')
+        cmd_string = string.join(list(map(self.escape, cmd)), ' ')
         if self.verbose:
             sys.stderr.write(cmd_string + "\n")
         if universal_newlines is None:
@@ -1319,7 +1320,7 @@ class TestCmd(object):
             if sub is None:
                 continue
             if is_List(sub):
-                sub = apply(os.path.join, tuple(sub))
+                sub = os.path.join(*tuple(sub))
             new = os.path.join(self.workdir, sub)
             try:
                 os.mkdir(new)
@@ -1409,7 +1410,7 @@ class TestCmd(object):
         """Find an executable file.
         """
         if is_List(file):
-            file = apply(os.path.join, tuple(file))
+            file = os.path.join(*tuple(file))
         if not os.path.isabs(file):
             file = where_is(file, path, pathext)
         return file
@@ -1431,7 +1432,7 @@ class TestCmd(object):
         the temporary working directory name with the specified
         arguments using the os.path.join() method.
         """
-        return apply(os.path.join, (self.workdir,) + tuple(args))
+        return os.path.join(*(self.workdir,) + tuple(args))
 
     def readable(self, top, read=1):
         """Make the specified directory tree readable (read == 1)
@@ -1508,12 +1509,12 @@ class TestCmd(object):
                 def do_chmod(fname):
                     try: st = os.stat(fname)
                     except OSError: pass
-                    else: os.chmod(fname, stat.S_IMODE(st[stat.ST_MODE]|0200))
+                    else: os.chmod(fname, stat.S_IMODE(st[stat.ST_MODE]|0o200))
             else:
                 def do_chmod(fname):
                     try: st = os.stat(fname)
                     except OSError: pass
-                    else: os.chmod(fname, stat.S_IMODE(st[stat.ST_MODE]&~0200))
+                    else: os.chmod(fname, stat.S_IMODE(st[stat.ST_MODE]&~0o200))
 
         if os.path.isfile(top):
             do_chmod(top)
@@ -1586,7 +1587,7 @@ class TestCmd(object):
         """
         file = self.canonicalize(file)
         if mode[0] != 'w':
-            raise ValueError, "mode must begin with 'w'"
+            raise ValueError("mode must begin with 'w'")
         with open(file, mode) as f:
             f.write(content)
 
diff --git a/media/webrtc/trunk/tools/gyp/test/lib/TestCommon.py b/media/webrtc/trunk/tools/gyp/test/lib/TestCommon.py
index a6e89ac32b..3e881168d8 100644
--- a/media/webrtc/trunk/tools/gyp/test/lib/TestCommon.py
+++ b/media/webrtc/trunk/tools/gyp/test/lib/TestCommon.py
@@ -184,7 +184,7 @@ else:
     module_suffix = '.so'
 
 def is_List(e):
-    return type(e) is types.ListType \
+    return type(e) is list \
         or isinstance(e, UserList.UserList)
 
 def is_writable(f):
@@ -227,7 +227,7 @@ class TestCommon(TestCmd):
         calling the base class initialization, and then changing directory
         to the workdir.
         """
-        apply(TestCmd.__init__, [self], kw)
+        TestCmd.__init__(*[self], **kw)
         os.chdir(self.workdir)
 
     def must_be_writable(self, *files):
@@ -237,13 +237,13 @@ class TestCommon(TestCmd):
         them.  Exits FAILED if any of the files does not exist or is
         not writable.
         """
-        files = map(lambda x: is_List(x) and apply(os.path.join, x) or x, files)
+        files = [is_List(x) and os.path.join(*x) or x for x in files]
         existing, missing = separate_files(files)
-        unwritable = filter(lambda x, iw=is_writable: not iw(x), existing)
+        unwritable = list(filter(lambda x, iw=is_writable: not iw(x), existing))
         if missing:
-            print "Missing files: `%s'" % string.join(missing, "', `")
+            print("Missing files: `%s'" % string.join(missing, "', `"))
         if unwritable:
-            print "Unwritable files: `%s'" % string.join(unwritable, "', `")
+            print("Unwritable files: `%s'" % string.join(unwritable, "', `"))
         self.fail_test(missing + unwritable)
 
     def must_contain(self, file, required, mode = 'rb'):
@@ -252,11 +252,11 @@ class TestCommon(TestCmd):
         file_contents = self.read(file, mode)
         contains = (string.find(file_contents, required) != -1)
         if not contains:
-            print "File `%s' does not contain required string." % file
-            print self.banner('Required string ')
-            print required
-            print self.banner('%s contents ' % file)
-            print file_contents
+            print("File `%s' does not contain required string." % file)
+            print(self.banner('Required string '))
+            print(required)
+            print(self.banner('%s contents ' % file))
+            print(file_contents)
             self.fail_test(not contains)
 
     def must_contain_all_lines(self, output, lines, title=None, find=None):
@@ -323,10 +323,10 @@ class TestCommon(TestCmd):
         pathname will be constructed by concatenating them.  Exits FAILED
         if any of the files does not exist.
         """
-        files = map(lambda x: is_List(x) and apply(os.path.join, x) or x, files)
-        missing = filter(lambda x: not os.path.exists(x), files)
+        files = [is_List(x) and os.path.join(*x) or x for x in files]
+        missing = [x for x in files if not os.path.exists(x)]
         if missing:
-            print "Missing files: `%s'" % string.join(missing, "', `")
+            print("Missing files: `%s'" % string.join(missing, "', `"))
             self.fail_test(missing)
 
     def must_match(self, file, expect, mode = 'rb'):
@@ -341,7 +341,7 @@ class TestCommon(TestCmd):
         except KeyboardInterrupt:
             raise
         except:
-            print "Unexpected contents of `%s'" % file
+            print("Unexpected contents of `%s'" % file)
             self.diff(expect, file_contents, 'contents ')
             raise
 
@@ -351,11 +351,11 @@ class TestCommon(TestCmd):
         file_contents = self.read(file, mode)
         contains = (string.find(file_contents, banned) != -1)
         if contains:
-            print "File `%s' contains banned string." % file
-            print self.banner('Banned string ')
-            print banned
-            print self.banner('%s contents ' % file)
-            print file_contents
+            print("File `%s' contains banned string." % file)
+            print(self.banner('Banned string '))
+            print(banned)
+            print(self.banner('%s contents ' % file))
+            print(file_contents)
             self.fail_test(contains)
 
     def must_not_contain_any_line(self, output, lines, title=None, find=None):
@@ -395,10 +395,10 @@ class TestCommon(TestCmd):
         which case the pathname will be constructed by concatenating them.
         Exits FAILED if any of the files exists.
         """
-        files = map(lambda x: is_List(x) and apply(os.path.join, x) or x, files)
-        existing = filter(os.path.exists, files)
+        files = [is_List(x) and os.path.join(*x) or x for x in files]
+        existing = list(filter(os.path.exists, files))
         if existing:
-            print "Unexpected files exist: `%s'" % string.join(existing, "', `")
+            print("Unexpected files exist: `%s'" % string.join(existing, "', `"))
             self.fail_test(existing)
 
     def must_not_be_writable(self, *files):
@@ -408,13 +408,13 @@ class TestCommon(TestCmd):
         them.  Exits FAILED if any of the files does not exist or is
         writable.
         """
-        files = map(lambda x: is_List(x) and apply(os.path.join, x) or x, files)
+        files = [is_List(x) and os.path.join(*x) or x for x in files]
         existing, missing = separate_files(files)
-        writable = filter(is_writable, existing)
+        writable = list(filter(is_writable, existing))
         if missing:
-            print "Missing files: `%s'" % string.join(missing, "', `")
+            print("Missing files: `%s'" % string.join(missing, "', `"))
         if writable:
-            print "Writable files: `%s'" % string.join(writable, "', `")
+            print("Writable files: `%s'" % string.join(writable, "', `"))
         self.fail_test(missing + writable)
 
     def _complete(self, actual_stdout, expected_stdout,
@@ -427,21 +427,21 @@ class TestCommon(TestCmd):
             expect = ''
             if status != 0:
                 expect = " (expected %s)" % str(status)
-            print "%s returned %s%s" % (self.program, str(_status(self)), expect)
-            print self.banner('STDOUT ')
-            print actual_stdout
-            print self.banner('STDERR ')
-            print actual_stderr
+            print("{} returned {}{}".format(self.program, str(_status(self)), expect))
+            print(self.banner('STDOUT '))
+            print(actual_stdout)
+            print(self.banner('STDERR '))
+            print(actual_stderr)
             self.fail_test()
         if not expected_stdout is None and not match(actual_stdout, expected_stdout):
             self.diff(expected_stdout, actual_stdout, 'STDOUT ')
             if actual_stderr:
-                print self.banner('STDERR ')
-                print actual_stderr
+                print(self.banner('STDERR '))
+                print(actual_stderr)
             self.fail_test()
         if not expected_stderr is None and not match(actual_stderr, expected_stderr):
-            print self.banner('STDOUT ')
-            print actual_stdout
+            print(self.banner('STDOUT '))
+            print(actual_stdout)
             self.diff(expected_stderr, actual_stderr, 'STDERR ')
             self.fail_test()
 
@@ -463,20 +463,18 @@ class TestCommon(TestCmd):
                 arguments = options + " " + arguments
 
         try:
-            return apply(TestCmd.start,
-                         (self, program, interpreter, arguments, universal_newlines),
-                         kw)
+            return TestCmd.start(*(self, program, interpreter, arguments, universal_newlines), **kw)
         except KeyboardInterrupt:
             raise
-        except Exception, e:
-            print self.banner('STDOUT ')
+        except Exception as e:
+            print(self.banner('STDOUT '))
             try:
-                print self.stdout()
+                print(self.stdout())
             except IndexError:
                 pass
-            print self.banner('STDERR ')
+            print(self.banner('STDERR '))
             try:
-                print self.stderr()
+                print(self.stderr())
             except IndexError:
                 pass
             cmd_args = self.command_args(program, interpreter, arguments)
@@ -501,7 +499,7 @@ class TestCommon(TestCmd):
                         command.  A value of None means don't
                         test exit status.
         """
-        apply(TestCmd.finish, (self, popen,), kw)
+        TestCmd.finish(*(self, popen,), **kw)
         match = kw.get('match', self.match)
         self._complete(self.stdout(), stdout,
                        self.stderr(), stderr, status, match)
@@ -539,7 +537,7 @@ class TestCommon(TestCmd):
                 arguments = options + " " + arguments
         kw['arguments'] = arguments
         match = kw.pop('match', self.match)
-        apply(TestCmd.run, [self], kw)
+        TestCmd.run(*[self], **kw)
         self._complete(self.stdout(), stdout,
                        self.stderr(), stderr, status, match)
 
